/***
 * $Source: /usr/home/ldl/langs/fm/RCS/fm.c,v $
 * $Revision: 0.19980909 $ $Date: 1998/09/09 20:46:27 $
 *
 * FM - Femto-M[UMPS].
 * Also, was derived, originally from the focal distribution
 * the ESR/et-al, retrocomputing museum... which caught my
 * eye, as it said Focal (which I knew) resembled MUMPS... sort of.
 */

#ifdef	vms
#include	<stsdef.h>
#include	<ssdef.h>
#define	IO_SUCCESS	SS$_NORMAL
#define	IO_ERROR	(STS$M_INHIB_MSG | SS$_ABORT)
#else
#ifndef	IO_SUCCESS
#define	IO_SUCCESS	0
#endif
#ifndef	IO_ERROR
#define	IO_ERROR	1
#endif
#endif

#define	IS_MAIN
#include	"fm.h"

/**
 *	Local functions.
 */
static
int	is_dup_tag		PROTO_ARGS((Line *));
static
void    getusercmd		PROTO_ARGS((void));
static
void	inject			PROTO_ARGS((Line *));

int
main()							/* Program	*/
{
/*
	init();

	setjmp(env);
	catchcc();
 */
	for (;;) {
		getusercmd();
		if (cline) {
			inject(cline);
			cline = (Line *)NULL;
			continue;
		} else {
			process(clp);
		}
	}
	return 0;
} /* main */

void
do_zload(pc)						/* Function	*/
	Command *pc;
{
	char    arg[BUFSIZ], buf[BUFSIZ], rtn[BUFSIZ], *ap;
	FILE   *f;

	if (pc->cmd_arg.size) {
		sprintf(arg, "%.*s",
			(int)    pc->cmd_arg.size,
			(char *) pc->cmd_arg.data);
	} else {
		if (strlen(routinename) == 0) {
			diag("no routine");
			return;
		}
		strcpy(arg, routinename);
	}

/*
printf("zload: arg='%s'\n", arg);
 */
	ap = arg;
	while (strlen(ap) && sscanf(ap, "%[^,]", buf)) {
		ap += strlen(buf) + 1;
/*
printf("zload: buf='%s', ap='%s'\n", buf, ap);
 */
		sprintf(rtn, "%s.m", buf);
		if (! (f = fopen(rtn, "r")) ) {
			perror(rtn);
			return;
		}
		while (fgets(buf, sizeof(buf), f)) {
			inject(compile(buf, 1));
		}
		fclose(f);
		strcpy(routinename, buf);
	}
} /* do_zload */

void
do_zprint(pc)						/* Function	*/
	Command *pc;
{
	char   *ap;
	Line   *sl = (Line *)NULL, *el = (Line *)NULL;

	if (pc->cmd_arg.size) {		/* Specified a range		*/
		char    stag[BUFSIZ], etag[BUFSIZ], arg[BUFSIZ], dmsg[BUFSIZ];
		int     soff = 0, eoff = 0, n;

					/* Init stuff			*/
		sprintf(arg, "%.*s",
			(int)   pc->cmd_arg.size,
			(char *)pc->cmd_arg.data);
		strcpy(stag, "");
		strcpy(etag, "");

		ap = arg;
/*
printf("zprint start ap=%s\n", ap);
 */
		n = sscanf(ap, "%[^+:]+%d", stag, &soff);
		if (n == 0) {
			sprintf(dmsg, "bad tag %s", ap);
			diag(dmsg);
			return;
		}
/*
printf("zprint: n=%d stag=%s soff=%d\n", n, stag, soff);
 */
					/* Now set sl on range		*/
		for (sl = routine;  sl;  sl = sl->l_next) {
			if (sl->l_tag && (strcmp(sl->l_tag, stag) == 0)) {
				n = soff;
				while ((n-- > 0) && sl)
					sl = sl->l_next;
				break;
			}
		}
		if (! sl) {		/* Tag not found		*/
			if (soff)
				sprintf(dmsg, "no line %d after %s",
					soff, stag);
			else
				sprintf(dmsg, "no tag %s found", stag);
			diag(dmsg);
			return;
		}
		if (! (ap = strchr(arg, ':'))) {
			el = sl;
			goto Do_ZPrint;
		}
/*
printf("zprint end ap=%s\n", ap);
 */
		n = sscanf(++ap, "%[^+:]+%d", etag, &eoff);
		if (n == 0) {
			sprintf(dmsg, "bad ending tag %s", ap);
			diag(dmsg);
			return;
		}
/*
printf("zprint: n=%d etag=%s eoff=%d\n", n, etag, eoff);
 */
		n = strlen(etag);	/* Now set el on range		*/
		for (el = routine;  el;  el = el->l_next) {
			if (el->l_tag && (strcmp(el->l_tag, etag) == 0))
				break;	/* Found ending tag		*/
		}
		if (! el) {		/* Tag not found		*/
			sprintf(dmsg, "no tag %s found", etag);
			diag(dmsg);
			return;
		}
					/* Note: stay stuck on last line*/
		n = eoff;		/* if necessary... too big is ok*/
		while ((n-- > 0) && el) {
			if (el->l_next)
				el = el->l_next;
		}
					/* Sanity check on range	*/
		{ /* block */
			Line   *l;
			for (l = sl;  l && (l != el);  l = l->l_next)
				;	/* See what stops		*/
			if (! l) {
				sprintf(dmsg, "bad range %s", arg);
				diag(dmsg);
				return;
			}
		} /* block */
	} else {			/* No range specified -- do all	*/
		for (sl = el = clp = routine;
			  clp;
				  el = clp, clp = clp->l_next)
			;		/* Skip out to end of routine	*/
	}
Do_ZPrint:
	clp = sl;			/* Output from start to end-1	*/
	while (clp != el) {
		decompile(stdout, clp);
		clp = clp->l_next;
	}
	decompile(stdout, clp);		/* Output end leave it as clp	*/
} /* do_zprint */

/**
 *	Remove whatever is in the routine buffer
 */
void
do_zremove(pc)						/* Function	*/
	Command *pc;
{
	while ((clp = routine)) {
/*
printf("zremove: clp=0x%p\n", clp);
 */
		routine = clp->l_next;
		freeLine(clp);
	}
} /* do_zremove */

/**
 *	Save what ever is in the routine buffer 
 */
void
do_zsave(pc)						/* Function	*/
	Command *pc;
{
	char	buf[BUFSIZ];
	FILE   *f;
	Line   *l;

	if (pc->cmd_arg.size) {
		sprintf(buf, "%.*s.m",
			(int)   pc->cmd_arg.size,
			(char *)pc->cmd_arg.data);
	} else {
		strcpy(buf, routinename);
	}

	if ((f = fopen(buf, "w"))) {
		for (l = routine;  l;  l = l->l_next)
			decompile(f, l);
		fclose(f);
	} else
		perror(buf);
} /* do_zsave */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/ 

static
void
getusercmd()						/* Function	*/
{
	int	xeq;
	char   *bp;

	cline = (Line *)NULL;

	putchar('>');
	if (gets(cbuf + 1) == NULL) {
		putchar('\n');
		exit(0);		/* FOR NOW */
	}

/*
printf("getusercmd: got '%s'\n", cbuf + 1);
 */
	for (bp = cbuf + 1;  *bp;  ++bp) {
		if (! (isalnum(*bp) || (*bp == '%')) ) {
/*
printf("getusercmd: taking break\n");
 */
			break;
		}
	}
/*
printf("getusercmd: at '%s'\n", bp);
 */
	if (*bp == '\t') {		/* Tab after tag,		*/
		xeq = 0;		/*   so defer execution		*/
		bp  = cbuf + 1;		/* Point to tag			*/
	} else {
		xeq = 1;		/* Immediate execute		*/
		bp  = cbuf;		/* Point before so looks like	*/
		*bp = ' ';		/*   a line without a tag	*/
	}

/*
printf("getusercmd: compile '%s' %sallowing tag\n", bp, xeq ? "not " : "");
 */
	cline = compile(bp, !xeq);	/* Compile the line		*/
/*
printf("------------------------------------\n%s execution\n",
xeq ? "Immediate" : "Deferred");
decompile(stdout, cline);
 */
	if (cline && xeq) {
		process(cline);
		freeLine(cline);
		cline = (Line *)NULL;
	}
} /* getusercmd */

/**
 * Inject a compiled line into the routine,
 * based on the current line position.
 */
void
inject(line)						/* Function	*/
	Line   *line;
{
	if (line->l_tag && is_dup_tag(line)) {
		char	buf[BUFSIZ];
		sprintf(buf, "duplicate tag %s\n", line->l_tag);
		diag(buf);
		freeLine(line);
		line = (Line *)NULL;
	}
/*
printf("inject: clp=0x%p routine=0x%p\n", clp, routine);
 */
	if (line && ! clp) {		/* No current line position	*/
/*
printf("inject: no current position\n");
 */
		if (! routine) {	/* No routine started yet	*/
/*
printf("inject: no routine, start it\n");
 */
			routine = clp = line;
			line = (Line *)NULL;
		} else {
/*
printf("inject: go to end of routine\n");
 */
			clp = routine;	/* Add to end of routine	*/
			while (clp->l_next)
				clp = clp->l_next;
/*
printf("inject: last line of routine 0x%p\n", clp);
 */
		}
	}
/*
printf("inject: clp=0x%p line=0x%p\n", clp, line);
 */
	if (line) {			/* Now insert after clp		*/
		line->l_next = clp->l_next;
		clp->l_next = line;
		clp = line;
/*
printf("inject: new clp=0x%p\n", clp);
 */
	}
} /* inject */

static
int
is_dup_tag(line)					/* Function	*/
	Line   *line;
{
	Line   *l;
	for (l = routine;  l;  l = l->l_next) {
		if (l->l_tag && (strcmp(l->l_tag, line->l_tag) == 0))
			return 1;
	}
	return 0;
} /* is_dup_tag */

/* End of $Source: /usr/home/ldl/langs/fm/RCS/fm.c,v $ */
