/***
 * $Source: /usr/home/ldl/langs/fm/RCS/lkup.c,v $
 * $Revision: 0.19980909 $ $Date: 1998/09/09 20:46:28 $
 *
 * FM - Femto-M[UMPS].
 * Initialization.
 */

#include "fm.h"

/**
 *	Linkage to intrinsic functions:	$FUNCTION(args)
 */
#include "intrinsics.h"
static					/* Intrinsic functions		*/
struct {				/* ----------------------------	*/
	char   *name;			/* Function name		*/
	MStrFn  func;			/* Function that does work	*/
	int	minabbr;		/* Minimum abbreviation		*/
	int	minargs;		/* Minimum number of args	*/
	int	maxargs;		/* Maximum number of args	*/
}      	intrinsics[] = {
	/*  name         func     minabbr minargs maxargs		*/
	{ "ASCII",      if_ascii,       1,   1,   2		},
	{ "CHAR",       if_char,        1,   1,  -1		},
	{ "DATA",       if_data,        1,   1,   1		},
	{ "EXTRACT",    if_extract,     1,   1,   3		},
	{ "FIND",       if_find,        1,   2,   3		},
	{ "FNUMBER",    if_fnumber,     2,   2,   3		},
	{ "GET",        if_get,         1,   1,   2		},
	{ "INCREMENT",  if_increment,   1,   1,   2		},
	{ "JUSTIFY",    if_justify,     1,   2,   3		},
	{ "LENGTH",     if_length,      1,   1,   2		},
	{ "NAME",       if_name,        2,   1,   2		},
	{ "ORDER",      if_order,       1,   1,   2		},
	{ "PIECE",      if_piece,       1,   2,   4		},
	{ "QLENGTH",    if_qlength,     2,   1,   1		},
	{ "QSUBSCRIPT", if_qsubscript,  2,   2,   2		},
	{ "QUERY",      if_query,       1,   1,   2		},
	{ "RANDOM",     if_random,      1,   1,   1		},
	{ "REVERSE",    if_reverse,     2,   1,   1		},
	{ "STACK",      if_stack,       2,   1,   2		},
	{ "TEXT",       if_text,        1,   1,   1		},
	{ "TRANSLATE",  if_translate,   2,   2,   3		},
	{ "VIEW",       if_view,        1,   1,   3		},
	{ "ZABS",       if_zabs,        4,   1,   1		},
	{ "ZARCCOS",    if_zarccos,     7,   1,   1		},
	{ "ZARCSIN",    if_zarcsin,     7,   1,   1		},
	{ "ZARCTAN",    if_zarctan,     7,   1,   1		},
	{ "ZBITAND",    if_zbitand,     7,   1,   1		},
	{ "ZBITCOUNT",  if_zbitcount,   9,   1,   1		},
	{ "ZBITFIND",   if_zbitfind,    8,   2,   3		},
	{ "ZBITGET",    if_zbitget,     7,   2,   2		},
	{ "ZBITLEN",    if_zbitlen,     7,   1,   1		},
	{ "ZBITNOT",    if_zbitnot,     7,   1,   1		},
	{ "ZBITOR",     if_zbitor,      6,   2,   2		},
	{ "ZBITSET",    if_zbitset,     7,   3,   3		},
	{ "ZBITSTR",    if_zbitstr,     7,   2,   2		},
	{ "ZBITXOR",    if_zbitxor,     7,   2,   2		},
	{ "ZBOOLEAN",   if_zboolean,    8,   3,   3		},
	{ "ZCONVERT",   if_zconvert,    8,   2,   3		},
	{ "ZCVT",       if_zconvert,    4,   2,   3		},
	{ "ZCOS",       if_zcos,        4,   1,   1		},
	{ "ZCOT",       if_zcot,        4,   1,   1		},
	{ "ZCRC",       if_zcrc,        4,   2,   3		},
	{ "ZCSC",       if_zcsc,        4,   1,   1		},
	{ "ZCYC",       if_zcyc,        2,   1,   1		},
	{ "ZDATE",      if_zdate,       2,   1,   9		},
	{ "ZDATEH",     if_zdateh,      6,   1,   9		},
	{ "ZDH",        if_zdateh,      3,   1,   9		},
	{ "ZDATETIME",  if_zdatetime,   9,   1,  11		},
	{ "ZDT",        if_zdatetime,   3,   1,  11		},
	{ "ZDATETIMEH", if_zdatetimeh, 10,   1,  10		},
	{ "ZDTH",       if_zdatetimeh,  4,   1,  10		},
	{ "ZEXP",       if_zexp,        4,   1,   1		},
	{ "ZF",         if_zf,          2,   1,  -1		},
	{ "ZHEX",       if_zhex,        2,   1,   1		},
	{ "ZINCREMENT", if_zincrement,  5,   1,   2		},
	{ "ZLASCII",    if_zlascii,     3,   1,   2		},
	{ "ZLCHAR",     if_zlchar,      3,   1,   1		},
	{ "ZLN",        if_zln,         3,   1,   1		},
	{ "ZLOG",       if_zlog,        4,   1,   1		},
	{ "ZNEXT",      if_znext,       5,   1,   1		},
	{ "ZORDER",     if_zorder,      2,   1,   1		},
	{ "ZPOWER",     if_zpower,      6,   2,   2		},
	{ "ZPREVIOUS",  if_zprevious,   2,   1,   1		},
	{ "ZSEARCH",    if_zsearch,     3,   1,   1		},
	{ "ZSEC",       if_zsec,        4,   1,   1		},
	{ "ZSEEK",      if_zseek,       5,   1,   2		},
	{ "ZSIN",       if_zsin,        4,   1,   1		},
	{ "ZSORT",      if_zsort,       5,   1,   2		},
	{ "ZSQR",       if_zsqr,        4,   1,   1		},
	{ "ZTAN",       if_ztan,        4,   1,   1		},
	{ "ZTIME",      if_ztime,       2,   1,   4		},
	{ "ZTIMEH",     if_ztimeh,      2,   1,   2		},
	{ "ZTH",        if_ztimeh,      3,   1,   2		},
	{ "ZU",         if_zu,          2,   2,   4		},
	{ "ZWASCII",    if_zwascii,     3,   1,   2		},
	{ "ZWCHAR",     if_zwchar,      3,   1,   1		},
	{ 0 		                                        }
};
int	n_intrinsics = sizeof(intrinsics) / sizeof(intrinsics[0]) - 1;

MStrFn
lkup_ifnc(name, minargs, maxargs)			/* Function	*/
	char   *name;
	int    *minargs;
	int    *maxargs;
{
	int	i, ln = strlen(name);
	char    buf[BUFSIZ], uname[BUFSIZ];

	str2upper(uname, name);
				/* hack - linear lookup */
	for (i = 0;  i < n_intrinsics;  ++i) {
		if ((strcmp (uname, intrinsics[i].name) == 0) ||
		    ((ln == intrinsics[i].minabbr) &&
		     (strncmp(uname, intrinsics[i].name, ln) == 0))
		   ) {
			*minargs = intrinsics[i].minargs;
			*maxargs = intrinsics[i].maxargs;
			return intrinsics[i].func;
		}
	}
	diag(buf);
	return (MStrFn)NULL;
} /* lkup_ifnc */

char *
ifnc2name(ifn)						/* Function	*/
	MStrFn	ifn;
{
	int	i;
	for (i = 0;  i < n_intrinsics;  ++i) {
		if (ifn == intrinsics[i].func)
			return intrinsics[i].name;
	}
	diag("ifnc2name: no such function");
	return NULL;
} /* ifnc2name */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/

/**
 *	Linkage to special variables:  $VARNAME
 */
#include "special_vars.h"
static					/* Intrinsic functions		*/
struct {				/* ----------------------------	*/
	char   *name;			/* Function name		*/
	MStrFn  func;			/* Function that does work	*/
	int	minabbr;		/* Minimum abbreviation		*/
}      	special_vars[] = {
	/*  name         func     minabbr				*/
	{ "DEVICE",     sv_device,      6			},
	{ "ECODE",      sv_ecode,       2			},
	{ "ESTACK",     sv_estack,      2			},
	{ "ETRAP",      sv_etrap,       2			},
	{ "HOROLOG",    sv_horolog,     1			},
	{ "IO",         sv_io,          1			},
	{ "JOB",        sv_job,         1			},
	{ "KEY",        sv_key,         1			},
	{ "PRINCIPAL",  sv_principal,   1			},
	{ "QUIT",       sv_quit,        1			},
	{ "STACK",      sv_stack,       2			},
	{ "STORAGE",    sv_storage,     1			},
	{ "TEST",       sv_test,        1			},
	{ "TLEVEL",     sv_tlevel,      2			},
	{ "X",          sv_x,           1			},
	{ "Y",          sv_y,           1			},
	{ "ZA",         sv_za,          2			},
	{ "ZB",         sv_zb,          2			},
	{ "ZCHILD",     sv_zchild,      2			},
	{ "ZERR",       sv_zerr,        4			},
	{ "ZHOROLOG",   sv_zhorolog,    2			},
	{ "ZIO",        sv_zio,         2			},
	{ "ZJOB",       sv_zjob,        4			},
	{ "ZMODE",      sv_zmode,       5			},
	{ "ZN",         sv_zn,          2			},
	{ "ZNSPACE",    sv_znspace,     7			},
	{ "ZORDER",     sv_zorder,      2			},
	{ "ZPARENT",    sv_zparent,     2			},
	{ "ZPI",        sv_zpi,         3			},
	{ "ZREFERENCE", sv_zreference,  2			},
	{ "ZSTORAGE",   sv_zstorage,    2			},
	{ "ZTIMESTAMP", sv_ztimestamp, 10			},
	{ "ZTRAP",      sv_ztrap,       2			},
	{ "ZVERSION",   sv_zversion,    2			},
	{ 0 		                                        }
};
int	n_special_vars = sizeof(special_vars) / sizeof(special_vars[0]) - 1;

MStrFn
lkup_svar(name)						/* Function	*/
	char   *name;
{
	int	i, ln = strlen(name);
	char    buf[BUFSIZ], uname[BUFSIZ];

	str2upper(uname, name);
				/* hack - linear lookup */
	for (i = 0;  i < n_special_vars;  ++i) {
		if ((strcmp (uname, special_vars[i].name) == 0) ||
		    ((ln == special_vars[i].minabbr) &&
		     (strncmp(uname, special_vars[i].name, ln) == 0))
		   ) {
			return special_vars[i].func;
		}
	}
	sprintf(buf, "unknown special var: %s", name);
	diag(buf);
	return (MStrFn)NULL;
} /* lkup_svar */
 
char *
svar2name(svar)						/* Function	*/
	MStrFn	svar;
{
	int	i;
	for (i = 0;  i < n_special_vars;  ++i) {
		if (svar == special_vars[i].func)
			return special_vars[i].name;
	}
	diag("svar2name: no such special variable");
	return NULL;
} /* svar2name */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/

#ifdef	NOT_DEFINED
ssvn
	g{lobal}
	j{ob}
	l{ock}
	r{outine}
#endif*/NOT_DEFINED*/

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/


/**
 *	Linkage to intrinsic functions:	MCOMMAND
 *
 *	Note:	The op2name function assumes that the:
 *		- first entry of an opcode is the minimum abbreviation
 *		- last entry of an opcode is the one that has the full name
 */
#include "opcode.h"
static					/* Intrinsic functions		*/
struct {				/* ----------------------------	*/
	char   *name;			/* Command name			*/
	Mop     opcode;			/* Operation code		*/
	int     postcond;		/* Allowed to have a postcond	*/
	int	arg;			/* NO/Opt/Req args      ARG_xxx	*/
}      	commands[] = {
	/*  command	opcode      postcond  arg		*/
	{ "B",		OP_BREAK,	1,    ARG_OPT			},
	{ "BREAK",	OP_BREAK,	1,    ARG_OPT			},
	{ "C",		OP_CLOSE,	1,    ARG_RQRD			},
	{ "CLOSE",	OP_CLOSE,	1,    ARG_RQRD			},
	{ "D",		OP_DO,		1,   (ARG_OPT |ARG_LIST)	},
	{ "DO",		OP_DO,		1,   (ARG_OPT |ARG_LIST)	},
	{ "E",		OP_ELSE,	0,    ARG_NONE			},
	{ "ELSE",	OP_ELSE,	0,    ARG_NONE			},
	{ "F",		OP_FOR,		0,    ARG_OPT			},
	{ "FOR",	OP_FOR,		0,    ARG_OPT			},
	{ "G",		OP_GOTO,	1,   (ARG_OPT |ARG_LIST)	},
	{ "GOTO",	OP_GOTO,	1,   (ARG_OPT |ARG_LIST)	},
	{ "H",		OP_HALT,	1,    ARG_NONE			},
	{ "H",		OP_HANG,	1,    ARG_RQRD			},
	{ "HALT",	OP_HALT,	1,    ARG_NONE			},
	{ "HANG",	OP_HANG,	1,    ARG_RQRD			},
	{ "I",		OP_IF,		0,   (ARG_OPT |ARG_LIST)	},
	{ "IF",		OP_IF,		0,   (ARG_OPT |ARG_LIST)	},
	{ "J",		OP_JOB,		1,   (ARG_RQRD|ARG_LIST)	},
	{ "JOB",	OP_JOB,		1,   (ARG_RQRD|ARG_LIST)	},
	{ "K",		OP_KILL,	1,   (ARG_OPT |ARG_LIST)	},
	{ "KILL",	OP_KILL,	1,   (ARG_OPT |ARG_LIST)	},
	{ "L",		OP_LOCK,	1,    ARG_OPT			},
	{ "LOCK",	OP_LOCK,	1,    ARG_OPT			},
	{ "M",		OP_MERGE,	1,   (ARG_OPT |ARG_LIST)	},
	{ "MERGE",	OP_MERGE,	1,   (ARG_OPT |ARG_LIST)	},
	{ "N",		OP_NEW,		1,   (ARG_OPT |ARG_LIST)	},
	{ "NEW",	OP_NEW,		1,   (ARG_OPT |ARG_LIST)	},
	{ "O",		OP_OPEN,	1,   (ARG_RQRD|ARG_LIST)	},
	{ "OPEN",	OP_OPEN,	1,   (ARG_RQRD|ARG_LIST)	},
	{ "Q",		OP_QUIT,	1,   (ARG_OPT |ARG_LIST)	},
	{ "QUIT",	OP_QUIT,	1,   (ARG_OPT |ARG_LIST)	},
	{ "R",		OP_READ,	1,   (ARG_RQRD|ARG_LIST)	},
	{ "READ",	OP_READ,	1,   (ARG_RQRD|ARG_LIST)	},
	{ "S",		OP_SET,		1,   (ARG_RQRD|ARG_LIST)	},
	{ "SET",	OP_SET,		1,   (ARG_RQRD|ARG_LIST)	},
	{ "TC",		OP_TCOMMIT,	1,    ARG_NONE			},
	{ "TCOMMIT",	OP_TCOMMIT,	1,    ARG_NONE			},
	{ "TR",		OP_TROLLBACK,	1,    ARG_NONE			},
	{ "TROLLBACK",	OP_TROLLBACK,	1,    ARG_NONE			},
	{ "TS",		OP_TSTART,	1,    ARG_NONE			},
	{ "TSTART",	OP_TSTART,	1,    ARG_NONE			},
	{ "U",		OP_USE,		1,    ARG_RQRD			},
	{ "USE",	OP_USE,		1,    ARG_RQRD			},
	{ "V",		OP_VIEW,	1,    ARG_RQRD			},
	{ "VIEW",	OP_VIEW,	1,    ARG_RQRD			},
	{ "W",		OP_WRITE,	1,   (ARG_OPT |ARG_LIST)	},
	{ "WRITE",	OP_WRITE,	1,   (ARG_OPT |ARG_LIST)	},
	{ "X",		OP_XECUTE,	1,   (ARG_OPT |ARG_LIST)	},
	{ "XECUTE",	OP_XECUTE,	1,   (ARG_OPT |ARG_LIST)	},
	{ "ZA",		OP_ZA,		0,   (ARG_RQRD|ARG_LIST)	},
	{ "ZB",		OP_ZBREAK,	0,    ARG_NONE			},
	{ "ZBREAK",	OP_ZBREAK,	0,    ARG_NONE			},
	{ "ZD",		OP_ZD,		1,   (ARG_RQRD|ARG_LIST)	},
	{ "ZI",		OP_ZINSERT,	0,    ARG_RQRD			},
	{ "ZINSERT",	OP_ZINSERT,	0,    ARG_RQRD			},
	{ "ZK",		OP_ZKILL,	0,    ARG_RQRD			},
	{ "ZKILL",	OP_ZKILL,	0,    ARG_RQRD			},
	{ "ZL",		OP_ZLOAD,	1,   (ARG_OPT |ARG_LIST)	},
	{ "ZLOAD",	OP_ZLOAD,	1,   (ARG_OPT |ARG_LIST)	},
	{ "ZN",		OP_ZNSPACE,	0,    ARG_RQRD			},
	{ "ZNSPACE",	OP_ZNSPACE,	0,    ARG_RQRD			},
	{ "ZP",		OP_ZPRINT,	0,    ARG_OPT			},
	{ "ZPRINT",	OP_ZPRINT,	0,    ARG_OPT			},
	{ "ZQ",		OP_ZQ,		0,    ARG_OPT			},
	{ "ZR",		OP_ZREMOVE,	0,    ARG_OPT			},
	{ "ZREMOVE",	OP_ZREMOVE,	0,    ARG_OPT			},
	{ "ZS",		OP_ZSAVE,	0,    ARG_OPT			},
	{ "ZSAVE",	OP_ZSAVE,	0,    ARG_OPT			},
	{ "ZSYNC",	OP_ZSYNC,	0,    ARG_NONE			},
	{ "ZTRAP",	OP_ZTRAP,	1,    ARG_OPT			},
	{ "ZW",		OP_ZWRITE,	0,    ARG_OPT			},
	{ "ZWRITE",	OP_ZWRITE,	0,    ARG_OPT			},
	{ "ZZDUMP",	OP_ZZDUMP,	0,    ARG_RQRD			},
	{ NULL								}
};
int	n_commands = sizeof(commands) / sizeof(commands[0]) - 1;

MVMOp
lkup_opcode(cmd, post, arg)				/* Function	*/
	char   *cmd;
	int    *post;
	int    *arg;
{
	int	i;
	char    buf[BUFSIZ], ucmd[BUFSIZ];

	str2upper(ucmd, cmd);
				/* hack - linear lookup */
	for (i = 0;  i < n_commands;  ++i)
		if (strcmp(ucmd, commands[i].name) == 0) {
			*post = commands[i].postcond;
			*arg  = commands[i].arg;
			return  commands[i].opcode;
		}
	sprintf(buf, "unknown command: %s", cmd);
	diag(buf);
	return OP__NONE;
} /* lkup_opcode */

char *
op2name(opcode, longnm)					/* Function	*/
	MVMOp	opcode;
	int     longnm;
{
	int	i, start, inc, term;

	switch (opcode) {
	case OP__COMMENT:
		return "";
	}

	start = longnm ? n_commands : 0;
	term  = longnm ? 0          : n_commands;
	inc   = longnm ? -1         : 1;

	for (i = start;  i != term;  i += inc) {
		if (opcode == commands[i].opcode)
			return commands[i].name;
	}

	diag("op2name: no such command");
	return NULL;
} /* op2name */

#ifdef	NOT_DEFINED
commands
	b{reak}{:pc} {breakargument}
	c{lose}{:pc} closeargument
	d{o}{:pc} {doargument{,...}}
	e{lse}
	f{or} {forargument}
	g{oto}{:pc} {gotoargument{,...}}
	h{alt}{:pc}
	h{ang}{:pc} hangargument
	i{f} {ifargument{,...}}
	j{ob}{:pc} jobargument{,...}
	k{ill}{:pc} {killargument{,...}}
	l{ock}{:pc} {lockargument}
	m{erge}{:pc} {mergeargument{,...}}
	n{ew}{:pc} {newargument{,...}}
	o{pen}{:pc} openargument{,...}
	q{uit}{:pc} {quitargument}
	r{ead}{:pc} readargument{,...}
	s{et}{:pc} setargument{,...}
	tc{ommit}{:pc}
	tr{ollback}{:pc}
	ts{tart}{:pc}
	u{se}{:pc} useargument
	v{iew}{:pc} viewargument
	w{rite}{:pc} {writeargument{,...}}
	x{ecute}{:pc} xecuteargument{,...}
	za{:pc} argument{,...}
	zb{reak}
	zd{:pc} argument{,...}
	zi{nsert} argument
	zk{ill} argument
	zl{oad}{:pc} {argument}
	zn{space} argument
	zp{rint} {argument}
	zq {argument}
	zr{emove} {argument}
	zsync
	zs{ave} {argument}
	ztrap{:pc} {argument}
	zw{rite} {argument}
	zzdump argument
#endif/*NOT_DEFINED*/

/* End of $Source: /usr/home/ldl/langs/fm/RCS/lkup.c,v $ */
