/***
 * $Source: /usr/home/ldl/langs/fm/RCS/process.c,v $
 * $Revision: 0.19980909 $ $Date: 1998/09/09 20:46:28 $
 *
 * FM - Femto-M[UMPS].
 * Process the MVMOp codes.
 */

#include "fm.h"
#include "opcode.h"

/**
 *	Local functions.
 */
/*
static
void    getusercmd		PROTO_ARGS((void));
 */

void
process(line)						/* Function	*/
	Line   *line;
{
	char    buf[BUFSIZ];
	Command *pc = (Command *)NULL;
	MStr	result;
	int     cmd, postcond;

/*
printf("process entered\n");
 */
	cmd = 0;

loop:
/*
printf("process:loop line=0x%p, pc=0x%p clp=0x%p cmd=%d\n",
line, pc, clp, cmd);
 */
	if (intflag) {
		intflag = 0;
		diag("execute a ^C");
	}

	if (! line)			/* No line			*/
		return;			/**!!! probably wrong !!!	*/
	if (cmd == line->l_ncmd) {	/* At end of commands on line	*/
		line = line->l_next;
		cmd  = 0;		/* Start at the first command	*/
		if ( line )
			goto loop;
		return;			/**!!! probably wrong !!!	*/
	}

	pc = line->l_cmd + cmd++;	/* Program counter		*/

/**
 *	Note: The compile() of a command tells us whether or not a
 *	postconditional is allowed, so we don't check... If there is
 *	one there, it gets executed.
 */
	postcond = 1;
	if (pc->cmd_postcond.size) {	/* Evaluate postconditional	*/
/*
		result = eval(pc->cmd_postcond);
 */
		postcond = atoi((char *)pc->cmd_postcond.data);
	}

	if (! postcond)			/* No postconditional so skip	*/
		goto loop;		/*   to next command on line	*/

	switch (pc->cmd_op) {	
	default:
		sprintf(buf, "unknown opcode %d", pc->cmd_op);
		fatal(buf);
	case OP__NONE:
		break;
	case OP_BREAK:			/* ARG_OPT			*/
		diag("execute a break");
		break;
	case OP_CLOSE:			/* ARG_RQRD			*/
		diag("execute a close");
		break;
	case OP_DO:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a do");
		break;
	case OP_ELSE:			/* ARG_NONE			*/
		diag("execute a else");
		break;
	case OP_FOR:			/* ARG_OPT			*/
		diag("execute a for");
		break;
	case OP_GOTO:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a goto");
		break;
	case OP_HALT:			/* ARG_NONE			*/
		exit( 0 );
		break;
	case OP_HANG:			/* ARG_RQRD			*/
		diag("execute a hang");
		break;
	case OP_IF:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a if");
		break;
	case OP_JOB:			/* ARG_RQRD | ARG_LIST		*/
		diag("execute a job");
		break;
	case OP_KILL:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a kill");
		break;
	case OP_LOCK:			/* ARG_OPT			*/
		diag("execute a lock");
		break;
	case OP_MERGE:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a merge");
		break;
	case OP_NEW:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a new");
		break;
	case OP_OPEN:			/* ARG_RQRD | ARG_LIST		*/
		diag("execute a open");
		break;
	case OP_QUIT:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a quit");
		break;
	case OP_READ:			/* ARG_RQRD | ARG_LIST		*/
		diag("execute a read");
		break;
	case OP_SET:			/* ARG_RQRD | ARG_LIST		*/
		diag("execute a set");
		break;
	case OP_TCOMMIT:		/* ARG_NONE			*/
		diag("execute a tcommit");
		break;
	case OP_TROLLBACK:		/* ARG_NONE			*/
		diag("execute a trollback");
		break;
	case OP_TSTART:			/* ARG_NONE			*/
		diag("execute a tstart");
		break;
	case OP_USE:			/* ARG_RQRD			*/
		diag("execute a use");
		break;
	case OP_VIEW:			/* ARG_RQRD			*/
		diag("execute a view");
		break;
	case OP_WRITE:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a write");
		break;
	case OP_XECUTE:			/* ARG_OPT | ARG_LIST		*/
		diag("execute a xecute");
		break;
	case OP_ZA:			/* ARG_RQRD | ARG_LIST		*/
		diag("execute a za");
		break;
	case OP_ZBREAK:			/* ARG_NONE			*/
		diag("execute a zbreak");
		break;
	case OP_ZD:			/* ARG_RQRD | ARG_LIST		*/
		diag("execute a zd");
		break;
	case OP_ZINSERT:		/* ARG_RQRD			*/
		diag("execute a zinsert");
		break;
	case OP_ZKILL:			/* ARG_RQRD			*/
		diag("execute a zkill");
		break;
	case OP_ZLOAD:			/* ARG_OPT | ARG_LIST		*/
		do_zload(pc);
		break;
	case OP_ZNSPACE:		/* ARG_RQRD			*/
		diag("execute a znspace");
		break;
	case OP_ZPRINT:			/* ARG_OPT			*/
		do_zprint(pc);
		break;
	case OP_ZQ:			/* ARG_OPT			*/
		diag("execute a zq");
		break;
	case OP_ZREMOVE:		/* ARG_OPT			*/
		do_zremove(pc);
		break;
	case OP_ZSAVE:			/* ARG_OPT			*/
		do_zsave(pc);
		break;
	case OP_ZSYNC:			/* ARG_NONE			*/
		diag("execute a zsync");
		break;
	case OP_ZTRAP:			/* ARG_OPT			*/
		diag("execute a ztrap");
		break;
	case OP_ZWRITE:			/* ARG_OPT			*/
		diag("execute a zwrite");
		break;
	case OP_ZZDUMP:			/* ARG_RQRD			*/
		diag("execute a zzdump");
		break;
	case OP__ZZINVALID:
		diag("execute a _zzinvalid");
		break;
	case OP__COMMENT:
		diag("execute a _comment");
		break;
	}
	goto loop;
} /* process */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/ 

/* End of $Source: /usr/home/ldl/langs/fm/RCS/process.c,v $ */
